#ifndef _SDIINTERFACE_H
#define _SDIINTERFACE_H


#include "sdiclass.h"


//////////////////////////////////////////////////////////////////////
// Constants
//
const TCHAR szSDIAddrSet[] = _T("0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcde")
      _T("fghijklmnopqrstuvwxyz\"#$%&'()+,-./{|}~");
const TCHAR szBang[] = _T("!");


//////////////////////////////////////////////////////////////////////
// Functions
//
extern "C" __declspec(dllimport) SDIerror SendCmd(const CString& Cmd, TCHAR* szReturn, 
      DWORD dwBufferSize, DWORD * pdwReturn);

extern "C" __declspec(dllimport) SDIerror CollectData(const CString& Cmd, double* pdReturn, 
      DWORD dwBufferSize, DWORD* pdwReturn, DWORD dwTimeout, BOOL NoWait);

extern "C" __declspec(dllimport) void SDIAbort();

extern "C" __declspec(dllimport) void ClearSDIAbort();

extern "C" __declspec(dllimport) void InitializeSDI(LPCTSTR CommPort);

// The following function should be used with extreme caution! It reads (and, 
// therefore, empties!) the contents of the SDI receive buffer. SendCmd() 
// and CollectData() both access the SDI buffer as required and will fail 
// if this function is called by another task in the middle of their processing.
// This function exists so that the SDI Edit page in ViewSensors has a way to 
// poll for service requests and other raw SDI device data.
extern "C" __declspec(dllimport) bool ReadSDIBuffer(UCHAR* mbsBuf, int iBufSize);

#endif
