#ifndef INCLUDE_WIN32FIX
#define INCLUDE_WIN32FIX


#include <windows.h>
#include "win32fixrc.h"


/////////////////////////////////////// DESKTOP WIN32 //////////////////////////////////////////
#ifndef _WIN32_WCE
typedef signed      char        INT8;
typedef unsigned    char        UINT8;
typedef signed      short       INT16;
typedef unsigned    short       UINT16;
typedef signed      int         INT32;
typedef unsigned    int         UINT32;
typedef signed      __int64     INT64;
typedef unsigned    __int64     UINT64;
typedef unsigned    long        ULONG_PTR;

typedef INT8    *PINT8;
typedef UINT8   *PUINT8;
typedef INT16   *PINT16;
typedef UINT16  *PUINT16;
typedef INT32   *PINT32;
typedef UINT32  *PUINT32;
typedef INT64   *PINT64;
typedef UINT64  *PUINT64;

inline BOOL InterruptInitialize(DWORD idInt, HANDLE hEvent, LPVOID pvData, DWORD cbData) {return TRUE;};
inline void InterruptDone(DWORD idInt) {};
inline void InterruptDisable(DWORD idInt) {};
inline void __cdecl NKDbgPrintfW(LPCTSTR Fmt, ...) 
{
   TCHAR Str[1024]; 
   va_list Arg; 
   va_start(Arg, Fmt); 
   wvsprintf(Str, Fmt, Arg); 
   va_end(Arg); 
   OutputDebugString(Str);
};


/////////////////////////////////////// WCE WIN32 //////////////////////////////////////////
#else
#define sprintf #error Do not use this function it is not supported by retail CE builds
#define sscanf #error Do not use this function it is not supported by retail CE builds

extern "C" BOOL InterruptInitialize(DWORD idInt, HANDLE hEvent, LPVOID pvData, DWORD cbData);
extern "C" void InterruptDone(DWORD idInt);
extern "C" void InterruptDisable(DWORD idInt);

inline LPTSTR lstrcpyn(LPTSTR dest, LPCTSTR source, int count)
{
   LPTSTR start = dest;
   while ((count>1) && (*dest++ = *source++))    /* copy string */
      count--;
   if (count == 1)                              /* pad with a zeroe */
      *dest++ = '\0';
   return start;
}

#endif // _WIN32_WCE

/////////////////////////////////////// UNICODE //////////////////////////////////////////
#ifdef UNICODE
#define WCSTOMBS wcstombs
#define MBSTOWCS mbstowcs
#define WCSCAT wcscat
#define WCSUPR wcsupr
#define WCSCPY wcscpy
#define WCSCMP wcscmp
#define WCSLEN wcslen
#define WCSNCPY wcsncpy
#else
inline int strlcpy(TCHAR* Dest, const TCHAR* Source, int Len)
{
   int len = strlen(Source) + 1;
   if (len > Len)
   {
      memcpy(Dest, Source, Len);
      return Len;
   }
   else
   {
      memcpy(Dest, Source, len);
      return len-1;
   };
};
#define WCSTOMBS strlcpy
#define MBSTOWCS strlcpy
#define WCSCAT strcat
#define WCSUPR _strupr
#define WCSCPY strcpy
#define WCSCMP strcmp
#define WCSLEN strlen
#define WCSNCPY lstrcpyn
#endif // UNICODE

#endif // INCLUDE_WIN32FIX

